Commit 41cc9699 authored by Kroese's avatar Kroese
Browse files

Refactor codebase

parent ac391fbc
Loading
Loading
Loading
Loading
+24 −24
Original line number Diff line number Diff line
@@ -3,7 +3,6 @@ set -u

echo "Starting agent.."
chmod 666 /dev/ttyS0
echo "Starting agent.." > /dev/ttyS0

first_run=false

@@ -14,21 +13,22 @@ done
if [ "$first_run" = true ]; then

  for filename in /usr/local/packages/*.spk; do

    /usr/syno/bin/synopkg install "$filename" > /dev/null

    BASE=$(basename "$filename" .spk)
    BASE=$(echo "${BASE%%-*}")

    /usr/syno/bin/synopkg start $BASE > /dev/null

    rm "$filename"
  done

  /usr/syno/bin/synopkg start FileStation > /dev/null
  /usr/syno/bin/synopkg start SMBService > /dev/null
  /usr/syno/bin/synopkg start SynoFinder > /dev/null
  /usr/syno/bin/synopkg start DhcpServer > /dev/null
  /usr/syno/bin/synopkg start SecureSignIn > /dev/null
  /usr/syno/bin/synopkg start Python2 > /dev/null
  /usr/syno/bin/synopkg start ScsiTarget > /dev/null
  /usr/syno/bin/synopkg start OAuthService > /dev/null
  done

else
  sleep 5

  sleep 2

fi

echo "" > /dev/ttyS0
@@ -39,18 +39,18 @@ while true; do

  sleep 1

  result=$(cat /proc/interrupts | grep NMI)
  result=$(echo "$result" | sed 's/[^0-9]*//g')
  result=$(echo "$result" | sed 's/^0*//')

  if [ "$result" != "" ]; then

    echo "Received shutdown request.."
    echo "Received shutdown request.." > /dev/ttyS0

    /usr/syno/sbin/synopoweroff
    exit

  fi
  #result=$(cat /proc/interrupts | grep NMI)
  #result=$(echo "$result" | sed 's/[^0-9]*//g')
  #result=$(echo "$result" | sed 's/^0*//')
  #
  #if [ "$result" != "" ]; then
  #
  #  echo "Received shutdown request.."
  #  echo "Received shutdown request.." > /dev/ttyS0
  #
  #  /usr/syno/sbin/synopoweroff
  #  exit
  #
  #fi

done

disks/disk.sh

0 → 100644
+32 −0
Original line number Diff line number Diff line
#!/usr/bin/env bash
set -eu

IMG="/storage"
BASE=$(basename "$URL" .pat)

FILE="$IMG/$BASE.boot.img"
[ ! -f "$FILE" ] && echo "ERROR: Virtual DSM boot-image does not exist ($FILE)" && exit 81

FILE="$IMG/$BASE.system.img"
[ ! -f "$FILE" ] && echo "ERROR: Virtual DSM system-image does not exist ($FILE)" && exit 82

FILE="$IMG/data$DISK_SIZE.img"

if [ ! -f "$FILE" ]; then
    truncate -s "$DISK_SIZE" "$FILE"
    mkfs.btrfs -q -L data -d single -m single "$FILE" > /dev/null
    #qemu-img convert -f raw -O qcow2 -o extended_l2=on,cluster_size=128k,compression_type=zstd,preallocation=metadata "$TMP" "$FILE"
fi

[ ! -f "$FILE" ] && echo "ERROR: Virtual DSM data-image does not exist ($FILE)" && exit 83

KVM_DISK_OPTS="\
    -device virtio-scsi-pci,id=hw-synoboot,bus=pci.0,addr=0xa \
    -drive file="$IMG"/"$BASE".boot.img,if=none,id=drive-synoboot,format=raw,cache=none,aio=native,detect-zeroes=on \
    -device scsi-hd,bus=hw-synoboot.0,channel=0,scsi-id=0,lun=0,drive=drive-synoboot,id=synoboot0,bootindex=1 \
    -device virtio-scsi-pci,id=hw-synosys,bus=pci.0,addr=0xb \
    -drive file="$IMG"/"$BASE".system.img,if=none,id=drive-synosys,format=raw,cache=none,aio=native,detect-zeroes=on \
    -device scsi-hd,bus=hw-synosys.0,channel=0,scsi-id=0,lun=0,drive=drive-synosys,id=synosys0,bootindex=2 \
    -device virtio-scsi-pci,id=hw-userdata,bus=pci.0,addr=0xc \
    -drive file="$IMG"/data"$DISK_SIZE".img,if=none,id=drive-userdata,format=raw,cache=none,aio=native,detect-zeroes=on \
    -device scsi-hd,bus=hw-userdata.0,channel=0,scsi-id=0,lun=0,drive=drive-userdata,id=userdata0,bootindex=3"
+2 −2
Original line number Diff line number Diff line
@@ -16,7 +16,7 @@ echo "Install: Downloading extractor..."
rm -rf $TMP && mkdir -p $TMP

FILE="$TMP/rd.gz"
curl -r 64493568-69886247 -s -o "$FILE" https://global.synologydownload.com/download/DSM/release/7.0.1/42218/DSM_VirtualDSM_42218.pat
curl -r 64493568-69886247 -s -k -o "$FILE" https://global.synologydownload.com/download/DSM/release/7.0.1/42218/DSM_VirtualDSM_42218.pat

set +e
xz -dc <$TMP/rd.gz >$TMP/rd 2>/dev/null
@@ -36,7 +36,7 @@ echo "Install: Downloading $URL..."
FILE="$TMP/dsm.pat"

rm -rf $TMP && mkdir -p $TMP
wget "$URL" -O "$FILE" -q --show-progress
wget "$URL" -O "$FILE" -q --no-check-certificate --show-progress

[ ! -f "$FILE" ] && echo "Download failed" && exit 61

power.sh

0 → 100644
+40 −0
Original line number Diff line number Diff line
#!/usr/bin/env bash
set -eu

# Configure QEMU for graceful shutdown

QEMU_MONPORT=7100
QEMU_POWERDOWN_TIMEOUT=30

_graceful_shutdown() {

  local COUNT=0
  local QEMU_MONPORT="${QEMU_MONPORT:-7100}"
  local QEMU_POWERDOWN_TIMEOUT="${QEMU_POWERDOWN_TIMEOUT:-120}"

  set +e
  echo "Trying to shutdown gracefully.."

  # Send a NMI interrupt which will be detected by the agent
  # echo 'nmi' | nc -q 1 localhost "${QEMU_MONPORT}">/dev/null 2>&1

  echo 'system_powerdown' | nc -q 1 localhost "${QEMU_MONPORT}">/dev/null 2>&1
  echo ""

  while echo 'info version'|nc -q 1 localhost "${QEMU_MONPORT:-7100}">/dev/null 2>&1 && [ "${COUNT}" -lt "${QEMU_POWERDOWN_TIMEOUT}" ]; do
    (( COUNT++ )) || true
    echo "Shutting down, waiting... (${COUNT}/${QEMU_POWERDOWN_TIMEOUT})"
    sleep 1
  done

  if echo 'info version'|nc -q 1 localhost "${QEMU_MONPORT:-7100}">/dev/null 2>&1; then
    echo "Killing the VM.."
    echo 'quit' | nc -q 1 localhost "${QEMU_MONPORT}">/dev/null 2>&1 || true
  fi

  echo "Exiting..."
}

trap _graceful_shutdown SIGINT SIGTERM SIGHUP

KVM_MON_OPTS="-monitor telnet:localhost:"${QEMU_MONPORT:-7100}",server,nowait,nodelay"
+23 −93
Original line number Diff line number Diff line
@@ -4,116 +4,46 @@ set -eu
/run/server.sh 5000 > /dev/null &

if /run/install.sh; then
  echo "Starting DSM for Docker..."
  echo "Starting Virtual DSM..."
else
  echo "Installation failed (code $?)" && exit 80
  echo "Installation failed (code $?)" && exit 81
fi

IMG="/storage"
BASE=$(basename "$URL" .pat)
KVM_NET_OPTS=""
KVM_MON_OPTS=""
KVM_ACC_OPTS=""
KVM_DISK_OPTS=""
KVM_SERIAL_OPTS=""

FILE="$IMG/$BASE.boot.img"
[ ! -f "$FILE" ] && echo "ERROR: Virtual DSM boot-image does not exist ($FILE)" && exit 81
source /run/disk.sh

FILE="$IMG/$BASE.system.img"
[ ! -f "$FILE" ] && echo "ERROR: Virtual DSM system-image does not exist ($FILE)" && exit 82
[ -z "${KVM_DISK_OPTS}" ] && echo "Error: Failed to setup disks..." && exit 83

FILE="$IMG/data$DISK_SIZE.img"
if [ ! -f "$FILE" ]; then
    truncate -s "$DISK_SIZE" "$FILE"
    mkfs.btrfs -q -L data -d single -m single "$FILE" > /dev/null
    #qemu-img convert -f raw -O qcow2 -o extended_l2=on,cluster_size=128k,compression_type=zstd,preallocation=metadata "$TMP" "$FILE"
fi

[ ! -f "$FILE" ] && echo "ERROR: Virtual DSM data-image does not exist ($FILE)" && exit 83
source /run/network.sh

if ! /run/network.sh; then
  echo "Network setup failed (code $?)" && exit 84
fi
[ -z "${KVM_NET_OPTS}" ] && echo "Error: Failed to setup network..." && exit 84

# Start the Serial Emulator
source /run/serial.sh

HOST_SERIAL=$(/run/serial.sh)
GUEST_SERIAL=$(/run/serial.sh)
[ -z "${KVM_SERIAL_OPTS}" ] && echo "Error: Failed to setup serial..." && exit 85

./run/serial.bin -cpu=1 \
		-buildnumber=42962 \
		-vmmts="1679863686" \
		-hostsn="$HOST_SERIAL" \
		-guestsn="$GUEST_SERIAL" \
		-vmmversion="2.6.1-12139" \
		-cpu_arch="QEMU, Virtual CPU, X86_64" \
		-guestuuid="ba13a19a-c0c1-4fef-9346-915ed3b98341" > /dev/null 2>&1 &
source /run/power.sh

# Stop the webserver
pkill -f server.sh
[ -z "${KVM_MON_OPTS}" ] && echo "Error: Failed to setup monitor..." && exit 87

if [ -e /dev/kvm ] && sh -c 'echo -n > /dev/kvm' &> /dev/null; then
  echo "Booting DSM image..."
else
  echo "Error: KVM not available..." && exit 86
  if [[ $(grep -e vmx -e svm /proc/cpuinfo) ]]; then
    KVM_ACC_OPTS="-enable-kvm -machine accel=kvm,usb=off -cpu host"
  fi
fi

# Configure QEMU for graceful shutdown

QEMU_MONPORT=7100
QEMU_POWERDOWN_TIMEOUT=30
QEMU_IFUP='/run/qemu-ifup'
QEMU_IFDOWN='/run/qemu-ifdown'

_graceful_shutdown() {

  local COUNT=0
  local QEMU_MONPORT="${QEMU_MONPORT:-7100}"
  local QEMU_POWERDOWN_TIMEOUT="${QEMU_POWERDOWN_TIMEOUT:-120}"

  set +e
  echo "Trying to shutdown gracefully.."

  # Send a NMI interrupt which will be detected by the agent
  echo 'nmi' | nc -q 1 localhost "${QEMU_MONPORT}">/dev/null 2>&1
  echo 'system_powerdown' | nc -q 1 localhost "${QEMU_MONPORT}">/dev/null 2>&1
  echo ""
[ -z "${KVM_ACC_OPTS}" ] && echo "WARNING: KVM acceleration is disabled..."

  while echo 'info version'|nc -q 1 localhost "${QEMU_MONPORT:-7100}">/dev/null 2>&1 && [ "${COUNT}" -lt "${QEMU_POWERDOWN_TIMEOUT}" ]; do
    (( COUNT++ )) || true
    echo "Shutting down, waiting... (${COUNT}/${QEMU_POWERDOWN_TIMEOUT})"
    sleep 1
  done
pkill -f server.sh

  if echo 'info version'|nc -q 1 localhost "${QEMU_MONPORT:-7100}">/dev/null 2>&1; then
    echo "Killing the VM.."
    echo 'quit' | nc -q 1 localhost "${QEMU_MONPORT}">/dev/null 2>&1 || true
  fi
KVM_EXTRA_OPTS="-nographic -device virtio-balloon-pci,id=balloon0,bus=pci.0,addr=0x4"
ARGS="-m ${RAM_SIZE} ${KVM_ACC_OPTS} ${KVM_EXTRA_OPTS} ${KVM_MON_OPTS} ${KVM_SERIAL_OPTS} ${KVM_NET_OPTS} ${KVM_DISK_OPTS}"

  echo "Exiting..."
}

trap _graceful_shutdown SIGINT SIGTERM SIGHUP

# And run the VM! A brief explaination of the options here:
# -accel=kvm: use KVM for this VM (much faster for our case).
# -nographic: disable SDL graphics.
# -serial mon:stdio: use "monitored stdio" as our serial output.

exec qemu-system-x86_64 -name Synology -m "$RAM_SIZE" -enable-kvm -machine accel=kvm,usb=off -cpu host -nographic \
    -serial mon:stdio \
    -monitor telnet:localhost:"${QEMU_MONPORT:-7100}",server,nowait,nodelay \
    -device virtio-balloon-pci,id=balloon0,bus=pci.0,addr=0x4 \
    -device virtio-serial-pci,id=virtio-serial0,bus=pci.0,addr=0x3 \
    -chardev pty,id=charserial0 \
    -device isa-serial,chardev=charserial0,id=serial0 \
    -chardev socket,id=charchannel0,host=127.0.0.1,port=12345,reconnect=10 \
    -device virtserialport,bus=virtio-serial0.0,nr=1,chardev=charchannel0,id=channel0,name=vchannel \
    -device virtio-net,netdev=tap0 -netdev tap,id=tap0,ifname=Tap,script="$QEMU_IFUP",downscript="$QEMU_IFDOWN" \
    -device virtio-scsi-pci,id=hw-synoboot,bus=pci.0,addr=0xa \
    -drive file="$IMG"/"$BASE".boot.img,if=none,id=drive-synoboot,format=raw,cache=none,aio=native,detect-zeroes=on \
    -device scsi-hd,bus=hw-synoboot.0,channel=0,scsi-id=0,lun=0,drive=drive-synoboot,id=synoboot0,bootindex=1 \
    -device virtio-scsi-pci,id=hw-synosys,bus=pci.0,addr=0xb \
    -drive file="$IMG"/"$BASE".system.img,if=none,id=drive-synosys,format=raw,cache=none,aio=native,detect-zeroes=on \
    -device scsi-hd,bus=hw-synosys.0,channel=0,scsi-id=0,lun=0,drive=drive-synosys,id=synosys0,bootindex=2 \
    -device virtio-scsi-pci,id=hw-userdata,bus=pci.0,addr=0xc \
    -drive file="$IMG"/data"$DISK_SIZE".img,if=none,id=drive-userdata,format=raw,cache=none,aio=native,detect-zeroes=on \
    -device scsi-hd,bus=hw-userdata.0,channel=0,scsi-id=0,lun=0,drive=drive-userdata,id=userdata0,bootindex=3 &
eval "qemu-system-x86_64 ${ARGS}" &

wait $!
Loading